' helpers.inc

' network tools

dim LastNetMessage$

' build an HTTP GET request
function HTTPGet$(Server as string,PathFile as string,AcceptType as string)
  dim tmp as string 
  tmp =       "GET "     + PathFile + " HTTP/1.1" + LINE_END
  tmp = tmp + "HOST: "   + Server                 + LINE_END
  tmp = tmp + "ACCEPT: " + AcceptType             + HEADER_END
  return tmp
end function

' split server answer in header and message parts.
sub Seperate(answer$,&hdr$,&msg$)
  dim I as integer
  dim L as integer
  hdr$="":msg$="":L=Len(Answer$)
  if L<Len(HEADER_END) then return: end if
  while I<L
    I=I+1
    if Mid$(Answer$,I,Len(HEADER_END))=HEADER_END then
      hdr$=Left$ (Answer$,i-1)
      msg$=Right$(Answer$,L-(i+3))
      I=L ' signal end of loop
    end if
  wend
end sub

function GetIP$()
  dim hServer = TCPCreateClient("shiny3d.de",80)
  if hServer=False then 
    LastNetMessage$="error: in GetIP$(), TCPCreateClient()!"
    return ""
  end if
  ' build and send HTTP GET request
  dim msg$ = HTTPGet$("shiny3d.de","/ip.php","text/plain")
  if TCPWriteString(hServer,Msg$)<>Len(Msg$) then
    LastNetMessage$="error: in GetIP$(), TCPWriteString()!"
    TCPDeleteClient(hServer)
    return ""
  end if
  dim TimeOut = 5000  
  while not TCPServerData(hServer) and TimeOut>0
     Sleep(100):TimeOut=TimeOut-100
  wend
  if TimeOut<=0 then
    TCPDeleteClient(hServer)
    LastNetMessage$="error: in GetIP$(), timeout!"
    return ""
  end if
  dim Answer$,Header$ 
  TCPReadString(hServer,Answer$)
  TCPDeleteClient(hServer)
  ' split header and message
  Seperate(Answer$,Header$,Msg$)
  LastNetMessage$="ok: GetIP$()"
  return Msg$
end function


function GetIPExt$(Server$,Port,Pathfile$)
  dim hServer = TCPCreateClient(Server$,Port)
  if hServer=False then 
    LastNetMessage$="error: in GetIPExt$(), TCPCreateClient()!"
    return ""
  end if
  ' build and send HTTP GET request
  dim msg$ = HTTPGet$(Server$,Pathfile$,"text/plain")
  if TCPWriteString(hServer,Msg$)<>Len(Msg$) then
    LastNetMessage$="error: in GetIPExt$(), TCPWriteString()!"
    TCPDeleteClient(hServer)
    return ""
  end if
  dim TimeOut = 5000  
  while not TCPServerData(hServer) and TimeOut>0
     Sleep(100):TimeOut=TimeOut-100
  wend
  if TimeOut<=0 then
    TCPDeleteClient(hServer)
    LastNetMessage$="error: in GetIPExt$(), timeout!"
    return ""
  end if
  dim Answer$,Header$ 
  TCPReadString(hServer,Answer$)
  TCPDeleteClient(hServer)
  ' split header and message
  Seperate(Answer$,Header$,Msg$)
  LastNetMessage$="ok: GetIPExt$()"
  return Msg$
end function

' print a string and seperate it line by line
sub PrintList(&List$)
  dim char$,i=1
  dim l=Len(List$)
  while i<l
    char$=Mid$(List$,i,1)
    if Asc(char$)=13 or Asc(char$)=10 then 
      printr:i=i+1
    else
      print char$
    end if
    i=i+1
  wend
  printr
end sub

' ######################
' # FTP client support #
' ######################
' FTP MESSAGES 

' 1xx = ok task in work
const MSG_RESTART_MARKER_REPLY$               = "110"
const MSG_SERVICE_READY_IN_X_MINUTES$         = "120" 
const MSG_DC_OPEN_TRANSFER_STARTING$          = "125" ' DC = data conection
const MSG_OPEN_DC$                            = "150"
' 2xx = ok task done
const MSG_DONE_CMD_OK$                        = "200" ' (syntax) CMD = command
const MSG_DONE_CMD_SYNTAX_NOT_IMPLEMENTED$    = "202" ' (syntax) 
const MSG_DONE_SYS_HELP_ANSWER$               = "211" ' (info) SYS = system
const MSG_DONE_FOLDER_STATE$                  = "212" ' (info)
const MSG_DONE_FILE_STATE$                    = "213" ' (info)
const MSG_DONE_HELP_MESSAGE$                  = "214" ' (info)
const MSG_DONE_SYSTEM_TYPE$                   = "215" ' (info)
const MSG_DONE_READY_FOR_NEW_USER$            = "220" ' (connection)      
const MSG_DONE_CLOSING_CC$                    = "221" ' (connection) CC = control conection
const MSG_DONE_DC_OPEN_NO_TRANFER$            = "225" ' (connection)
const MSG_DONE_TRANFER_OK$                    = "226" ' (connection)
const MSG_DONE_ENTERING_PASSIVE_MODE$         = "227" ' (connection)
const MSG_DONE_USER_LOGGED_IN$                = "230" ' (account)
const MSG_DONE_FILE_ACTION$                   = "250" ' (server) REQ = requested
const MSG_DONE_PATH$                          = "257" ' (server)
' 3xx = ok but need more infos
const MSG_NEED_PASSWORD$                      = "331" ' (account)
const MSG_NEED_ACCOUNT$                       = "332" ' (account)
const MSG_NEED_FURTHER_INFO$                  = "350" ' (server) INFO = information
' 4xx = error
const MSG_ERROR_SERVICE_NOT_AVIABLE_CLOSE_CC$ = "421" ' (connection)
const MSG_ERROR_CANT_OPEN_DC$                 = "425" ' (connection)
const MSG_ERROR_DC_CLOSED_TRANFER_ABORTED$    = "426" ' (connection)
const MSG_ERROR_REQ_FILE_ACTION_UNAVIABLE$    = "450" ' (server)
const MSG_ERROR_REQ_ACTION_LOCAL_ERROR$       = "451" ' (server)
const MSG_ERROR_REQ_ACTION_OUTOF_MEMORY$      = "452" ' (server)
' 5xx = error aborted
const MSG_ABORTED_CMD_SYSNTAX_ERROR$          = "500" ' (syntax)
const MSG_ABORTED_PAR_SYSNTAX_ERROR$          = "501" ' (syntax) PAR = parameter
const MSG_ABORTED_CMD_NOT_IMPLEMENTED$        = "502" ' (syntax)
const MSG_ABORTED_BAD_CMD_SEQ$                = "503" ' (syntax) SEQ = sequence
const MSG_ABORTED_CMD_PAR_NOT_IMPLEMENTED$    = "504" ' (syntax) 
const MSG_ABORTED_NOT_LOGGED_IN$              = "530" ' (account)
const MSG_ABORTED_NEED_ACCOUNT_FOR_STORING$   = "532" ' (account)
const MSG_ABORTED_REQ_FILE_UNAVIABLE$         = "550" ' (server)
const MSG_ABORTED_REQ_ABORTED_UNKNOW_TYPE$    = "551" ' (server)
const MSG_ABORTED_REQ_ABORTED_OUT_OF_STORAGE$ = "552" ' (server)
const MSG_ABORTED_FILE_NAME_NOT_ALLOWED$      = "553" ' (server)             

' FTP COMMANDS
const CMD_ABORT$            = "ABOR" ' abort last command (and close DC) 
const CMD_ACCOUNT$          = "ACCT" ' extended user account
const CMD_ALLOCATE$         = "ALLO" ' allocate space for next file (+"####")
const CMD_APPEND$           = "APPE" ' append files (+"name")
const CMD_CHANGE_DIR_UP$    = "CDUP" ' change to parent directory  (one folder up ..)
const CMD_CHANGE_WORK_DIR$  = "CWD"  ' change work directory (+"folder")
const CMD_DELET_FILE$       = "DELE" ' delete file (+"file")
const CMD_GET_HELP$         = "HELP" ' print help
const CMD_GET_LIST$         = "LIST" ' receive list from folder (optional +" folder"
const CMD_MAKE_DIR$         = "MKD"  ' create directory (+"folder")
const CMD_GET_MLSD$         = "MLSD"  ' create directory (+"folder")
const CMD_SET_MODE$         = "MODE" ' set transfer mode  (+"S" = stream, +"B" = block, +"C" compressed)
const CMD_GET_NAMELIST$     = "NLST" ' receive name list
const CMD_DO_NOOP$          = "NOOP" ' no operations
const CMD_PASSWORD$         = "PASS" ' tranfer user password (+"password")
const CMD_PASSIVE$          = "PASV" ' request for passive connection
const CMD_SET_PORT$         = "PORT" ' set port address
const CMD_GET_WORK_DIR$     = "PWD"  ' receive current directory name
const CMD_QUIT$             = "QUIT" ' disconnect control channel
const CMD_RESTARD_CC$       = "REIN" ' close control connection and restart
const CMD_RESTARD_TRANSFER$ = "REST" ' restard file transfer (+"file pointer")
const CMD_GET_FILE$         = "RETR" ' receive file (+"file")
const CMD_DELETE_DIR$       = "RMD"  ' delete directory (+"folder")
const CMD_RENAME_FROM$      = "RNFR" ' old file name (+"file")
const CMD_RENAME_TO$        = "RNTO" ' new file name (+"file")
const CMD_GET_SERVER_INFO$  = "SITE" ' receive server information
const CMD_MOUNT$            = "SMNT" ' structure mount
const CMD_GET_STATUS$       = "STAT" ' receive current status
const CMD_STORE_FILE$       = "STOR" ' store file (+"file")
const CMD_STORE_UNIQUE$     = "STOU" ' store file under unic name (+"file")
const CMD_SET_STRUCTURE$    = "STRU" ' file structure  ( +"F" = File, +"R" = Record, +"P" = Page)
const CMD_GET_SYSTEM$       = "SYST" ' get server OS
const CMD_SET_TYPE$         = "TYPE" ' set type  (+"A" = ASCII  +"E" = EBCDIC +"C" = Carriage Control +"I" = Image)   (optional)  L <byte size> 
const CMD_USER$             = "USER" ' transfer user name

' a to large receive/transmit buffer makes no sence
const BLOCK_SIZE = 4096
const BLOCK_INTS = BLOCK_SIZE / 4
dim BUFFER(BLOCK_INTS-1)

' wait on answer but no longer than timeout (ms)
function GetMsg(hConnection,&Msg$,TimeOut)
  if hConnection = False then return False :end if
  dim Quit:Msg$=""
  while not TCPServerData(hConnection) and not Quit
    TimeOut=TimeOut-100:Sleep(100)
    if TimeOut<=0 then Quit=True:end if
  wend
  if Quit then
    LastNetMessage$="warning: GetMsg() TimeOut !"
    return False
  else
    LastNetMessage$="ok: GetMsg()"
    return TCPReadString(hConnection,Msg$)
  end if
 
end function   

function Is(Msg$,What$)
  return (left$(Msg$,3)=What$)
end function

function CMD(hConnection,Cmd$,Param$)
  if hConnection = False then return False :end if
  ' if any param be sure to have an " " seperator
  if len(Param$) land left$(Param$,1)<>" " then
    Param$=" "+Param$
  end if
  return TCPWriteString(hConnection,Cmd$ + Param$ + LINE_END) 
end function
 
' connect to server return hServer or False
function FTP_Connect(Server$,User$,Password$) 
  dim msg$
  dim LoggedIn,hServer
  hServer = TCPCreateClient(Server$,21)  ' FTP is allways port 21
  if hServer=False then 
    LastNetMessage$="error: in FTP_Connect(),TCPCreateClient()!"
    return False
  end if
  ' receive welcome message  
  if not GetMsg(hServer,Msg$,5000) then
    LastNetMessage$="error: in FTP_Connect() timeout!"
    TCPDeleteClient(hServer)
    return False
  end if

  if Is(Msg$,MSG_DONE_READY_FOR_NEW_USER$) then 
    ' some welcome messages are possible
    while GetMsg(hServer,Msg$,1000) and Is(Msg$,MSG_DONE_READY_FOR_NEW_USER$)
    wend
  else
    LastNetMessage$="error: in FTP_Connect() no welcome message >" + Msg$
    TCPDeleteClient(hServer)
    return False
  end if
  ' log in
  Cmd(hServer,CMD_USER$,User$) 
  if not GetMsg(hServer,Msg$,10000) then
    LastNetMessage$="error: in FTP_Connect() USER TimeOut!" 
    TCPDeleteClient(hServer)
    return False
  end if
  ' password needed ?
  if Is(Msg$,MSG_NEED_PASSWORD$) then
    Cmd(hServer,CMD_PASSWORD$,Password$)
    if not GetMsg(hServer,Msg$,10000) then
      LastNetMessage$="error: in FTP_Connect() PASS TimeOut!"
      TCPDeleteClient(hServer)
      return False
    end if
  end if
  ' now we are logged in ?      
  if not Is(Msg$,MSG_DONE_USER_LOGGED_IN$) then 
    LastNetMessage$="error: in FTP_Connect() not logged in! >" + Msg$
    TCPDeleteClient(hServer)
    return False
  end if
  ' some logged in messages are possible
  while GetMsg(hServer,Msg$,1000) and Is(Msg$,MSG_DONE_USER_LOGGED_IN$)
  wend

  Cmd(hServer,CMD_SET_TYPE$,"I") 
  if not GetMsg(hServer,Msg$,5000) then
    LastNetMessage$="error: in FTP_Connect() SET_TYPE TimeOut!" 
    TCPDeleteClient(hServer)
    return False
  end if

  if not Is(Msg$,MSG_DONE_CMD_OK$) then
    LastNetMessage$="error: in FTP_Connect() SET_TYPE missing done message!>" + Msg$
    TCPDeleteClient(hServer)
    return False
  end if
  LastNetMessage$="ok: FTP_Connect()" 
  ' ok so far
  return hServer
end function

' return hData or False
function FTP_OpenDataChannel(hServer)
  dim Msg$,IP$,ip1$,ip2$,ip3$,ip4$,pl$,ph$
  dim p=1,Port
  ' go in passive data mode
  Cmd(hServer,CMD_PASSIVE$,"") 
  if not GetMsg(hServer,Msg$,5000) then
    printr "error: in OpenDataChannel() timeout!" + Msg$
    return false
  end if
  
  while Is(Msg$,MSG_DONE_FILE_ACTION$)
    GetMsg(hServer,Msg$,5000)
  wend

  if not Is(Msg$,MSG_DONE_ENTERING_PASSIVE_MODE$) then
    printr "error: in OpenDataChannel()! >" + Msg$
    return false
  end if

  ' build IP from message "(123,12,123,1,,)" 
  while Mid$(Msg$,p,1)<>"(":                         p=p+1:wend:p=p+1 ' jump over "("
  while Mid$(Msg$,p,1)<>",":ip1$=ip1$+Mid$(Msg$,p,1):p=p+1:wend:p=p+1 ' jump over ","
  while Mid$(Msg$,p,1)<>",":ip2$=ip2$+Mid$(Msg$,p,1):p=p+1:wend:p=p+1 ' jump over ","
  while Mid$(Msg$,p,1)<>",":ip3$=ip3$+Mid$(Msg$,p,1):p=p+1:wend:p=p+1 ' jump over ","
  while Mid$(Msg$,p,1)<>",":ip4$=ip4$+Mid$(Msg$,p,1):p=p+1:wend:p=p+1 ' jump over ","
  IP$  = ip1$ + "." + ip2$ + "." + ip3$ + "." + ip4$
  ' build PORT from message "(,,,,123,12)" 
  while Mid$(Msg$,p,1)<>",":ph$=ph$+Mid$(Msg$,p,1):  p=p+1:wend:p=p+1 ' jump over ","
  while Mid$(Msg$,p,1)<>")":pl$=pl$+Mid$(Msg$,p,1):  p=p+1:wend
  Port = val(ph$)*256 + val(pl$)
  ' open data channel
  return TCPCreateClient(IP$,Port)
end function

' get folder listing
function FTP_LIST(hServer,&List$)
  dim Msg$,hData
  hData = FTP_OpenDataChannel(hServer)
  if not hData then return False: end if
  Cmd(hServer,CMD_GET_LIST$,"")
  if not GetMsg(hServer,Msg$,5000) or not Is(Msg$,MSG_OPEN_DC$) then
    TCPDeleteClient(hData)
    return false
  end if
  if not GetMsg(hData,List$,5000) then
    TCPDeleteClient(hData)
    LastNetMessage$="error: in FTP_LIST() timeout!"
    return false
  end if
  TCPDeleteClient(hData)
  if not GetMsg(hServer,Msg$,1000) then
    LastNetMessage$="warning: in FTP_LIST() time out for done message" 
  elseif not Is(Msg$,MSG_DONE_TRANFER_OK$) then
    LastNetMessage$="warning: in FTP_LIST() wrong answer" + Msg$
  else
    LastNetMessage$="ok: FTP_LIST()"
  end if
  return true
end function        

' get folder listing (new command not all FTP servers support it)
function FTP_MLSD(hServer,&List$)
  dim Msg$,hData
  hData = FTP_OpenDataChannel(hServer)
  if not hData then return False: end if
  Cmd(hServer,CMD_GET_MLSD$,"")
  
  if not GetMsg(hServer,Msg$,5000) then
    LastNetMessage$="error: in FTP_MLSD(), MLSD timeout!"
    TCPDeleteClient(hData)
    return false
  end if

  if Is(Msg$,MSG_ABORTED_CMD_SYSNTAX_ERROR$) then
    LastNetMessage$="error: in FTP_MLSD(), cmd not supported!"
    TCPDeleteClient(hData)
    return false
  end if
  
  if not Is(Msg$,MSG_OPEN_DC$) then
    LastNetMessage$="error: in FTP_MLSD(), no open dc ! >" + Msg$
    TCPDeleteClient(hData)
    return false
  end if
  
  if not GetMsg(hData,List$,5000) then
    TCPDeleteClient(hData)
    LastNetMessage$="error: in FTP_MLSD() timeout!"
    return false
  end if
  TCPDeleteClient(hData)
  if not GetMsg(hServer,Msg$,1000) then
    LastNetMessage$="warning: in FTP_MLSD() time out for done message" 
  elseif not Is(Msg$,MSG_DONE_TRANFER_OK$) then
    LastNetMessage$="warning: in FTP_MLSD() wrong answer" + Msg$
  else
    LastNetMessage$="ok: FTP_MLSD()"
  end if
  return true
end function

' print work directory
function FTP_PWD(hServer,&WD$)

  dim Msg$
  Cmd(hServer,CMD_GET_WORK_DIR$,"") 
  if not GetMsg(hServer,Msg$,5000) then
    LastNetMessage$="error: in FTP_PWD() timeout!"
    return false
  elseif not Is(Msg$,MSG_DONE_PATH$)  then
    LastNetMessage$="error: in FTP_PWD() wrong answer! >" + Msg$
    return false
  else
    LastNetMessage$="ok: FTP_PWD()"
  end if
  dim p=1:WD$=""
  while Mid$(Msg$,p,1)<>chr$(34):p=p+1:wend:p=p+1
  while Mid$(Msg$,p,1)<>chr$(34):WD$=WD$+Mid$(Msg$,p,1):p=p+1:wend
  return True
end function

' change work directory
function FTP_CWD(hServer,Dir$)
  if not hServer then return False:end if
  dim Msg$
  Cmd(hServer,CMD_CHANGE_WORK_DIR$,Dir$)
  if not GetMsg(hServer,Msg$,5000) then
    LastNetMessage$="error: in FTP_CWD() timeout!"
    return False
  elseif not Is(Msg$,MSG_DONE_FILE_ACTION$) then
    LastNetMessage$="warning: in FTP_CWD() wrong answer! >" + Msg$
  else
    LastNetMessage$="ok: FTP_CWD()"
  end if
  return True
end function

' quit session
function FTP_QUIT(hServer)
  if not hServer then return False:end if
  dim Msg$
  Cmd(hServer,CMD_QUIT$,"") 
  GetMsg(hServer,Msg$,2000)
  return true
end function

' disconnect
function FTP_Disconnect(&hServer)
  if hServer = false then return False :end if
  TCPDeleteClient(hServer)
  hServer=false
  return True
end function

' upload "store" SrcPathFile$ as DstPathFile$ on FTP server
' example: if FTP_STOR(hServer,"c:\folder\test.zip","/FolderOnServer/NameOnServer.zip") then
function FTP_STOR(hServer,SrcFile$,DstFile$)
  if hServer = false then return False :end if

  dim hFile = OpenFileRead(SrcFile$)
  if hFile = false then 
    LastNetMessage$="error: in FTP_STOR(), OpenFileRead()"
    return False
  end if
  ' get file size !!! very slow !!!
  dim Bytes
  while not EndOfFile(hFile)
    ReadByte(hFile)
    Bytes = Bytes + 1
  wend 
  CloseFile(hFile)
  ' here we can use seek but i reopen the file
  hFile = OpenFileRead(SrcFile$)
   
  dim hData = FTP_OpenDataChannel(hServer)
  if hData = false then 
    CloseFile(hFile)
    return False 
  end if  

  dim Msg$
  Cmd(hServer,CMD_STORE_FILE$,DstFile$)
  if not GetMsg(hServer,Msg$,5000) then
    LastNetMessage$="error: in FTP_STOR(), cmd stor timeout!"
    CloseFile(hFile):TCPDeleteClient(hData):return False
  elseif not Is(Msg$,MSG_OPEN_DC$) then
    LastNetMessage$="error: in FTP_STOR(), cmd stor wrong message >" + Msg$
    CloseFile(hFile):TCPDeleteClient(hData):return False
  end if
  print "start of transfer " 
  dim cx = CursorCol()
  dim cy = CursorRow()
  dim perc,operc,nRest,i
  dim nBlocks   = Bytes / BLOCK_SIZE
  dim RestBytes = Bytes % BLOCK_SIZE
  dim time#     = PerformanceCounter()
  while nRest<Bytes
    ' any buffer
    while nBlocks
      ' fill buffer
      For i=0 to BLOCK_INTS-1
        Buffer(i)=ReadInt(hFile)
      next
      ' transfer buffer
      TCPWriteIntArray(hData,Buffer)
      nBlocks = nBlocks-1
      nRest   = nRest + BLOCK_SIZE
      perc    = (nRest*100)/bytes
      if perc<>operc then
        locate cx,cy:print perc + "% done. "
        operc=perc
      end if
      
    wend
    ' any rest ?
    while RestBytes
      TCPWriteByte(hData,ReadByte(hFile))
      RestBytes = RestBytes - 1
      nRest     = nRest     + 1
      perc      = (nRest*100)/bytes
      if perc<>operc then
        locate cx,cy:print perc + "% done. "
        operc=perc
      end if
    wend
  wend
  time#=PerformanceCounter()-time#
  CloseFile(hFile):TCPDeleteClient(hData)
  printr
  printr "transfered " + bytes + " bytes in " +time#/1000 + " seconds"
  if not GetMsg(hServer,Msg$,1000) then
    LastNetMessage$="warning: FTP_STOR() timeout"
  elseif not Is(Msg$,MSG_DONE_TRANFER_OK$) then
    LastNetMessage$="warning: FTP_STOR() missing done message from server! >" + Msg$
    printr Msg$
  else
    LastNetMessage$="ok: FTP_STOR()"
  end if
  return True
end function

' This command behaves like FTP_STOR except that the resultant file 
' is to be created in the current directory under a name unique to that directory.
' unique name returned in DstFile$
function FTP_STOU(hServer,SrcFile$,&DstFile$)
  if hServer = false then return False :end if
  dim hFile,hData,bytes,Msg$,time#,nBlocks,Rest,i
 
  hFile=OpenFileRead(SrcFile$)
  if hFile = false then 
    LastNetMessage$="error: in FTP_STOU(), OpenFile()!"
    return False
  end if
  ' get file size !!! very slow !!!
  printr "GetFileSize()"
  while not EndOfFile(hFile)
    ReadByte(hFile)
    bytes=bytes+1
  wend 
  CloseFile(hFile)
  
  hFile=OpenFileRead(SrcFile$)
  nBlocks = bytes / BLOCK_SIZE
  Rest    = bytes % BLOCK_SIZE

  hData = FTP_OpenDataChannel(hServer)
  if hData = false then 
    CloseFile(hFile)
    LastNetMessage$="error: in FTP_STOU(), OpenDataChannel()!"
    return False 
  end if

  Cmd(hServer,CMD_STORE_UNIQUE$,"")
  if not GetMsg(hServer,Msg$,5000) or not Is(Msg$,MSG_OPEN_DC$) then
    LastNetMessage$="error: in FTP_STOU(), cmd stou! >" + Msg$
    CloseFile(hFile):TCPDeleteClient(hData):return False
  end if
  ' get UNIQUE file name from last message
  DstFile$=""
  i=1:while Mid$(Msg$,i,1)<>":":i=i+1:wend:i=i+1
  while i<len(Msg$)
    i=i+1
    if Mid$(Msg$,i,1)<>10 and Mid$(Msg$,i,1)<>13 then
      DstFile$=DstFile$+Mid$(Msg$,i,1)
    end if
  wend  
  print "transfer " + bytes + " bytes "
  dim cx = CursorCol()
  dim cy = CursorRow()
  dim perc as integer
  dim operc as integer
  dim nRest
  time#=PerformanceCounter()
  while nBlocks
    ' fill buffer
    For i=0 to BLOCK_INTS-1
      Buffer(i)=ReadInt(hFile)
    next
    ' transfer buffer
    TCPWriteIntArray(hData,Buffer)
    nBlocks=nBlocks-1
    nRest=nRest+BLOCK_SIZE
    perc=(nRest*100)/bytes
    if perc<>operc then
      locate cx,cy:print perc + "% done. "
      operc=perc
    end if
  wend
  while Rest
    TCPWriteByte(hData,ReadByte(hFile))
    Rest=Rest-1
  wend
  time#=PerformanceCounter()-time#
  CloseFile(hFile):TCPDeleteClient(hData)
  printr "transfered " + bytes + " bytes in " +time#/1000 + " seconds"
  if not GetMsg(hServer,Msg$,5000) then
    LastNetMessage$="warning: in FTP_STOU() timeout!"
  elseif not Is(Msg$,MSG_DONE_TRANFER_OK$) then
    LastNetMessage$="warning: missing done message from server! >"  + Msg$
  else
    LastNetMessage$="ok: in FTP_STOU()"
  end if
  return True
end function                                           

' Retrieve SrcFile$ from Server and save it as DstFile$
function FTP_RETR(hServer,SrcFile$,DstFile$)
  if hServer = false then return False :end if
  if len(SrcFile$)=0 or len(DstFile$)=0 then
    return False
  end if
  dim hFile=OpenFileWrite(DstFile$)
  if hFile=0 then return false:end if
  dim hData = FTP_OpenDataChannel(hServer)
  if hData = false then 
    CloseFile(hFile)
    LastNetMessage$="error: in FTP_RETR(), OpenDataChannel()!"
    return False 
  end if
  dim Msg$
   
  Cmd(hServer,CMD_GET_FILE$,SrcFile$)
  if not GetMsg(hServer,Msg$,5000) then
    LastNetMessage$="error: in FTP_RETR() timeout!"
    CloseFile(hFile)
    return False
  end if

  if not Is(Msg$,MSG_OPEN_DC$) then
    LastNetMessage$="error: in FTP_RETR() wrong answer>" + Msg$
    CloseFile(hFile)
    return False
  end if                                                              

  ' get file size from last message
  dim p=1,Size$
  while Mid$(Msg$,p,1)<>"(":p=p+1:wend:p=p+1
  while Mid$(Msg$,p,1)<>")"
    if Mid$(Msg$,p,1)<>" " then
      Size$=Size$+Mid$(Msg$,p,1)
    end if
    p=p+1
  wend
  dim Bytes = val(size$)
  dim i,n,nRec,nRest
  print "start receiving "
  dim cx = CursorCol()
  dim cy = CursorRow()
  dim perc,operc
  dim Time#=PerformanceCounter()
  while nRest<Bytes
    while TCPServerData(hData) 
      nRec  = TCPReadIntArray(hData,Buffer)
      nRest = nRest+nRec
      n = nRec / 4
      i=0
      while n
        WriteInt(hFile,Buffer(i))
        i=i+1:n=n-1
      wend
      ' any rest
      n = nRec % 4
      if n>0 then
        i=Buffer(i)
        while n 
          WriteByte(hfile,i and 0xFF)
          i=i/256:n=n-1
        wend
      end if
      perc=(nRest*100)/bytes
      if perc<>operc then
        locate cx,cy:print perc + "% done. "
        operc=perc
      end if
    wend
    sleep(100)
  wend
  Time#=PerformanceCounter()-Time#
  printr
  printr "received " + bytes + " bytes in " + Time#/1000 + " seconds"
  CloseFile(hFile):TCPDeleteClient(hData)
  if GetMsg(hServer,Msg$,2000) then
    if not Is(Msg$,MSG_DONE_TRANFER_OK$) then
      LastNetMessage$="warning: in FTP_RETR() wrong answer! >"+Msg$
    end if
  else
    LastNetMessage$="ok: FTP_RETR()"
  end if
  return True
end function           

' ######################
' # GameServer Service #
' ###################### 
const EXT$ = ".srv"
function GetGameServerInfo(GameName$,&IP$,&Port$)
  dim Server$ = "djpeters.dj.funpic.de"
  dim Path$   = "/games/"
  dim File$   = GameName$ + EXT$            
  IP$="":Port$=""
  dim hWeb    = TCPCreateClient(SERVER$,80)
  if not hWeb then
    LastNetMessage$="error: in GetGameServerInfo(), TCPCreateClient()!"
    return False
  end if                
  ' build and send HTTP GET request
  dim msg$ = HTTPGet$(SERVER$,PATH$ + FILE$,"text/plain")
  dim l    = len(msg$)
  dim ret  = TCPWriteString(hWeb,msg$)
  if ret<>l then
    LastNetMessage$="error: in GetGameServerInfo(), TCPWriteString()!"
    TCPDeleteClient(hWeb)
    return False
  end if
  dim TimeOut=10000
  while not TCPServerData(hWeb) and TimeOut>0
    Sleep(100):TimeOut=TimeOut-100
  wend        
  if timeOut<=0 then
    LastNetMessage$="error: in GetGameServerInfo(), TimeOut!"
    TCPDeleteClient(hWeb)
    return false
  end if
  dim answer$,header$ 
  l=TCPReadString(hWeb,answer$)
  TCPDeleteClient(hWeb)
  if l<28 then
    LastNetMessage$="error: in GetGameServerInfo(), wrong server entry!"
    return False
  end if 
  dim i,p1,p2
  for i=1 to l-5
    if p1=0 then
      if Mid$(answer$,i,6)=">>>>>>" then p1=i+6:end if
    elseif p2=0 then 
      if Mid$(answer$,i,6)="<<<<<<" then p2=i-1:end if
    end if  
  next     
  if p1=0 or p2=0 then                                                
    LastNetMessage$="error: in GetGameServerInfo(), no server entry!"
    return False
  end if
  if (p2-p1)=-1 then  
    LastNetMessage$="GameServer isn't online!"
    return false 
  end if
  i=p1
  while Mid$(answer$,i,1)<>":":IP$=IP$+Mid$(answer$,i,1):i=i+1:wend
  while i<p2:i=i+1:PORT$=PORT$+Mid$(answer$,i,1):wend
  LastNetMessage$="ok: GetGameServerInfo()"
  return true
end function

function RegisterGameServer(Name$,Port$)
  dim IP$ = GetIP$()
  if IP$ = "" then return false:end if
  dim hFile=OpenFileWrite(Name$+EXT$)
  if not hFile then 
    LastNetMessage$="error: in RegisterGameServer(),OpenFileWrite()"
    return false
  end if
  WriteLine(hFile,">>>>>>"+IP$+":"+Port$+"<<<<<<")
  CloseFile(hFile)
  dim hFTP = FTP_Connect("ftp.djpeters.dj.funpic.de","djpeters","ftp124816")
  if not hFTP then
    DeleteFile(Name$+EXT$)
    return false
  end if
  if not FTP_CWD(hFTP,"games") then
    DeleteFile(Name$+EXT$)
    FTP_QUIT(hFTP):FTP_Disconnect(hFTP)
    return false
  end if
  dim ok = FTP_STOR(hFTP,Name$+EXT$,Name$+EXT$)
  FTP_QUIT(hFTP)
  FTP_Disconnect(hFTP)
  DeleteFile(Name$+EXT$)
  if not ok then
    LastNetMessage$="error: in RegisterGameServer(),FTP_STOR()"
  else  
    LastNetMessage$="ok: RegisterGameServer()"
  end if
  return ok
end function

function UnRegisterGameServer(Name$)
  dim IP$ = GetIP$()
  if IP$ = "" then return false:end if
  dim hFile=OpenFileWrite(Name$+EXT$)
  if not hFile then 
    LastNetMessage$="error: in UnRegisterGameServer(),OpenFileWrite()"
    return false
  end if
  WriteLine(hFile,">>>>>><<<<<<")
  CloseFile(hFile)
  dim hFTP = FTP_Connect("ftp.djpeters.dj.funpic.de","djpeters","ftp124816")
  if not hFTP then
    LastNetMessage$="error: in UnRegisterGameServer(), FTP_Connect()!"
    DeleteFile(Name$+EXT$)
    return false
  end if
  if not FTP_CWD(hFTP,"games") then
    FTP_QUIT(hFTP):FTP_Disconnect(hFTP)
    LastNetMessage$="error: in UnRegisterGameServer(), FTP_CWD()"
    DeleteFile(Name$+EXT$)
    FTP_QUIT(hFTP):FTP_Disconnect(hFTP)
    return false
  end if
  dim ok = FTP_STOR(hFTP,Name$+EXT$,Name$+EXT$)
  FTP_QUIT(hFTP):FTP_Disconnect(hFTP)
  DeleteFile(Name$+EXT$)
  if not ok then 
    LastNetMessage$="error: in UnRegisterGameServer(), FTP_STOR()"
  else
    LastNetMessage$="ok: UnRegisterGameServer()"
  end if
  return ok
end function
