' "<$fbc>" -dll "<$file>" -x ..\TCPPlugin.dll
#include "\Basic4GL\Basic4GLMacros.bi"

const PLUG_DESC = "for Basic4GL"
const SOCKET_MAJOR = 0
const SOCKET_MINOR = 1

type TCPInit_t               as function () as integer
type TCPCreateServer_t       as function (p as integer) as integer
type TCPDeleteServer_t       as function () as integer
type TCPClientConnected_t    as function () as integer
type TCPClientDisconnected_t as function () as integer
type TCPClientData_t         as function () as integer
type TCPWrite_t              as function (c as integer, b as any ptr,s as integer) as integer
type TCPRead_t               as function (c as integer, b as any ptr,s as integer) as integer
type TCPCreateClient_t       as function (s as zstring ptr,p as integer) as integer
type TCPDeleteClient_t       as function (c as integer)  as integer
type TCPServerData_t         as function (c as integer)  as integer
type TCPServerIdle_t         as function (c as integer)  as integer
  
type TCPLIB
  pDll                   as any ptr 
  pTCPInit               as TCPInit_t
  pTCPCreateServer       as TCPCreateServer_t 
  pTCPDeleteServer       as TCPDeleteServer_t 
  pTCPClientConnected    as TCPClientConnected_t 
  pTCPClientDisconnected as TCPClientDisconnected_t
  pTCPClientData         as TCPClientData_t
  pTCPWrite              as TCPWrite_t
  pTCPRead               as TCPRead_t 
  pTCPCreateClient       as TCPCreateClient_t
  pTCPDeleteClient       as TCPDeleteClient_t
  pTCPServerData         as TCPServerData_t
  pTCPServerIdle         as TCPServerIdle_t
end type
dim shared as string errormsg
dim shared as TCPLIB wrapper 


extern "C"

DPF(TCPCreateServer) ' hServer%=TCPCreateServer(Port%)
  SIR(wrapper.pTCPCreateServer(GIP(1))) ' port
end sub
DPF(TCPDeleteServer)
  SIR(wrapper.pTCPDeleteServer()) ' hServer
end sub
DPF(TCPClientConnected)
  SIR(wrapper.pTCPClientConnected())
end sub
DPF(TCPClientDisconnected)
  SIR(wrapper.pTCPClientDisconnected())
end sub
DPF(TCPClientData)
  SIR(wrapper.pTCPClientData())
end sub

DPF(TCPWriteByte) ' h,byte
  dim as integer b=GIP(1) and &HFF
  SIR(wrapper.pTCPWrite(GIP(2),@b,1))
end sub
DPF(TCPWriteWord) ' h,word
  dim as integer w=GIP(1) and &HFFFF
  SIR(wrapper.pTCPWrite(GIP(2),@w,2))
end sub
DPF(TCPWriteInt) ' h,int
  dim as integer i=GIP(1)
  SIR(wrapper.pTCPWrite(GIP(2),@i,4))
end sub
DPF(TCPWriteSingle) ' h,single
  dim as single s=GFP(1)
  SIR(wrapper.pTCPWrite(GIP(2),@s,4))
end sub
DPF(TCPWriteIntArray) ' h,array()
  dim as integer n = GAPD(1,0)
  if n<1 then
    SIR(0)
    return
  end if
  dim as integer ptr pArray = allocate(n*4)
  GIA(1,pArray,n*4)
  dim as integer r = wrapper.pTCPWrite(GIP(2),pArray,n*4)
  deallocate pArray
  SIR(r)
end sub
DPF(TCPWritenInts) ' h,array(),n
  dim as integer n = GIP(1)
  if n<1 then
    SIR(0)
    return
  end if
  dim as integer ptr pArray = allocate(n*4)
  GIA(2,pArray,n*4)
  dim as integer r = wrapper.pTCPWrite(GIP(3),pArray,n*4)
  deallocate pArray
  SIR(r)
end sub

DPF(TCPReadByte) ' h,byte
  dim as integer i
  dim as integer r=wrapper.pTCPRead(GIP(2),@i,1)
  if r>0 then
    SIPR(1,@i)
  end if
  SIR(r)
end sub
DPF(TCPReadWord) ' h,word
  dim as integer i
  dim as integer r=wrapper.pTCPRead(GIP(2),@i,2)
  if r>0 then
    SIPR(1,@i)
  end if
  SIR(r)
end sub
DPF(TCPReadInt) ' h,int
  dim as integer i
  dim as integer r=wrapper.pTCPRead(GIP(2),@i,4)
  if r>0 then
    SIPR(1,@i)
  end if
  SIR(r)
end sub
DPF(TCPReadSingle) ' h,single
  dim as single s
  dim as integer r=wrapper.pTCPRead(GIP(2),@s,4)
  if r>0 then
    SFPR(1,@s)
  end if
  SIR(r)
end sub
DPF(TCPReadIntArray) ' h,array()
  dim as integer n = GAPD(1,0)
  if n<1 then
    SIR(0)
    return
  end if
  dim as integer ptr pArray = allocate(n*4)
  dim as integer r = wrapper.pTCPRead(GIP(2),pArray,n*4)
  if r>0 then
    SIA(1,pArray,n)
  end if
  deallocate pArray
  SIR(r)
end sub

DPF(TCPReadnInts) ' h,array(),nInts
  dim as integer n = GIP(1)
  if n<1 then
    SIR(0)
    return
  end if
  dim as integer ptr pArray = allocate(n*4)
  dim as integer r=wrapper.pTCPRead(GIP(3),pArray,n*4)
  r=r\4
  if r>0 then
    SIA(1,pArray,r)
  end if
  deallocate pArray
  SIR(r)
end sub

DPF(TCPCreateClient)
  SIR(wrapper.pTCPCreateClient(GSP(2),GIP(1))) ' server$,port
end sub
DPF(TCPDeleteClient)
  SIR(wrapper.pTCPDeleteClient(GIP(1))) ' hClient
end sub

DPF(TCPServerData)
  SIR(wrapper.pTCPServerData(GIP(1))) ' h
end sub

DPF(TCPServerIdle)
  SIR(wrapper.pTCPServerIdle(GIP(1))) ' h
end sub

DPF(TCPWriteString) ' h,string
  dim as zstring ptr s=GSP(1)
  dim as integer n = len(*s)
  if n>0 then
    SIR(wrapper.pTCPWrite(GIP(2),s,n))
  else
    SIR(0)
  end if
end sub

DPF(TCPReadString) ' h,string
  dim as integer ret,size=1024*8
  dim as zstring ptr pStr=callocate(size)
  ret=wrapper.pTCPRead(GIP(2),pStr,size)
  SSPR(1,ret,pStr)
  SIR(ret)
  deallocate pStr
end sub


' ##########
' # Plugin #
' ##########

function Load (THIS_PLUGIN, _
               THIS_REGISTRY, _
               blnIsExe as byte) as integer
  wrapper.pDll=dylibload("tcp.dll")
  if wrapper.pDll=0 then
    errormsg="fatal error: can't load tcp.dll !"
    return 0
  end if

  with wrapper
    .pTCPInit               = dylibsymbol(.pDll,"_TCPInit")
    .pTCPCreateServer       = dylibsymbol(.pDll,"_TCPCreateServer") 
    .pTCPDeleteServer       = dylibsymbol(.pDll,"_TCPDeleteServer") 
    .pTCPClientConnected    = dylibsymbol(.pDll,"_TCPClientConnected")
    .pTCPClientDisconnected = dylibsymbol(.pDll,"_TCPClientDisconnected")
    .pTCPClientData         = dylibsymbol(.pDll,"_TCPClientData")
    .pTCPWrite              = dylibsymbol(.pDll,"_TCPWrite")
    .pTCPRead               = dylibsymbol(.pDll,"_TCPRead") 
    .pTCPCreateClient       = dylibsymbol(.pDll,"_TCPCreateClient")
    .pTCPDeleteClient       = dylibsymbol(.pDll,"_TCPDeleteClient")
    .pTCPServerData         = dylibsymbol(.pDll,"_TCPServerData")
    .pTCPServerIdle         = dylibsymbol(.pDll,"_TCPServerIdle")
  end with
  if wrapper.pTCPInit()=0 then
    errormsg="error: can't init tcp layer !"
    return 0
  end if

  RSC (LINE_END,chr(13) & chr(10))
  RSC (HEADER_END,chr(13) & chr(10) & chr(13) & chr(10))

  RIF(TCPCreateServer):AIP
  RIF(TCPDeleteServer)
  RIF(TCPClientConnected)
  RIF(TCPClientDisconnected)
  RIF(TCPClientData)

  RIF(TCPWriteByte):AIP:AIP
  RIF(TCPWriteWord):AIP:AIP
  RIF(TCPWriteInt):AIP:AIP
  RIF(TCPWriteSingle):AIP:AFP
  RIF(TCPWriteIntArray):AIP: AIAP(1)
  RIF(TCPWritenInts):AIP: AIAP(1):AIP

  RIF(TCPReadByte):AIP:AIPR
  RIF(TCPReadWord):AIP:AIPR
  RIF(TCPReadInt):AIP:AIPR
  RIF(TCPReadSingle):AIP:AFPR
  RIF(TCPReadIntArray):AIP: AIAP(1)
  RIF(TCPReadnInts):AIP: AIAP(1):AIP


  RIF(TCPCreateClient):ASP:AIP
  RIF(TCPDeleteClient):AIP
  RIF(TCPServerData):AIP
  RIF(TCPServerIdle):AIP

  RIF(TCPWriteString):AIP:ASP
  RIF(TCPReadString):AIP:ASPR


  return 1
end function

sub Unload (THIS_PLUGIN)
  if wrapper.pDll then
    dylibfree wrapper.pDll
    wrapper.pDll=0
  end if
end sub

function Start (THIS_PLUGIN) as integer
  return 1
end function

sub      Ends (THIS_PLUGIN)

end sub

sub      Pause (THIS_PLUGIN)

end sub

sub      Resumed (THIS_PLUGIN)

end sub

sub      DelayedResume (THIS_PLUGIN)

end sub

sub      GetError  (THIS_PLUGIN,ErrMsg as zstring ptr)
  if len(errormsg) then
    for i as integer=0 to len(errormsg)-1
      ErrMsg[i]=errormsg[i]
    next
  end if
end sub

sub      ProcessMessages(THIS_PLUGIN)

end sub

' Query function
function Basic4GL_Query  alias "Basic4GL_Query" (byval details as string, _
                                                 byref major   as integer, _
                                                 byref minor   as integer) as integer export
  dim as string detailSrc = PLUG_DESC
  for i as integer = 0 to len(detailSrc)
    details[i] = detailSrc[i]
  next
  major = SOCKET_MAJOR
  minor = SOCKET_MINOR
  return BASIC4GL_DLL_VERSION
end function

dim shared as IDLL_Basic4GL_Plugin ptr Plugin
' Main initialisation function.
' Here we will construct and return our plugin object
function Basic4GL_Init  alias "Basic4GL_Init" () as IDLL_Basic4GL_Plugin ptr ptr export
  Plugin=new IDLL_Basic4GL_Plugin
  ' Construct and return our plugin object
  Plugin->Load           =@Load
  Plugin->Unload         =@Unload
  Plugin->Start          =@Start
  Plugin->Ends           =@Ends
  Plugin->Pause          =@Pause
  Plugin->Resumed        =@Resumed
  Plugin->DelayedResume  =@DelayedResume
  Plugin->GetError       =@GetError
  Plugin->ProcessMessages=@ProcessMessages

  return @Plugin
end function

end extern
